<template>
    <div class="app-container">
        <el-row :gutter="10" class="mb8">
            <el-col :span="1.5">
                <el-button type="primary" plain icon="el-icon-plus" size="mini" @click="handleAdd"
                    v-hasPermi="['member:memberGroup:add']">新增</el-button>
            </el-col>
            <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
        </el-row>

        <el-table v-loading="loading" :data="memberGroupList" @selection-change="handleSelectionChange">
            <el-table-column type="selection" width="55" align="center" />
            <el-table-column prop="groupCode" label="集团编号" align="center">
                <template slot-scope="scope">
                    <router-link :to="'/member/memberGroup/detail/' + scope.row.groupCode + `&${scope.row.merchantId}`"
                        class="link-type">
                        <span>{{ scope.row.groupCode }}</span>
                    </router-link>
                </template>
            </el-table-column>
            <el-table-column label="集团名称" align="center" prop="groupName" />
            <el-table-column label="运营商名称" align="center" prop="merchantName" />
            <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
                <template slot-scope="scope">
                    <el-button size="mini" type="text" icon="el-icon-delete" @click="handleDelete(scope.row)"
                        v-hasPermi="['member:memberGroup:remove']">删除</el-button>
                </template>
            </el-table-column>
        </el-table>

        <pagination v-show="total > 0" :total="total" :page.sync="queryParams.pageNum"
            :limit.sync="queryParams.pageSize" @pagination="getList" />

        <!-- 添加或修改会员组对话框 -->
        <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
            <el-form ref="form" :model="form" :rules="dialogRules" label-width="120px">
                <el-form-item label="选择运营商">
                    <el-select v-model="form.merchantId" clearable filterable placeholder="请选择运营商"
                        @change="changeSelectStation(form.merchantId)">
                        <el-option v-for="item in merchantList" :key="item.merchantId" :label="item.merchantName"
                            :value="item.merchantId">
                        </el-option>
                    </el-select>
                </el-form-item>
                <el-form-item label="集团名称" prop="groupName">
                    <el-input v-model="form.groupName" placeholder="请输入集团名称" />
                </el-form-item>
            </el-form>
            <div slot="footer" class="dialog-footer">
                <el-button type="primary" @click="submitForm">确 定</el-button>
                <el-button @click="cancel">取 消</el-button>
            </div>
        </el-dialog>
        <!--添加会员-->
        <el-dialog title="添加会员" :visible.sync="openAddMember" width="500px" append-to-body>
            添加会员
        </el-dialog>
    </div>
</template>

<script>
import { listMemberGroup, getMemberGroup, delMemberGroup, addMemberGroup, updateMemberGroup } from "@/api/member/memberGroup";
import { getMerchantListByAuth } from "@/api/member/info";
import { getStationListByMerchantId } from "@/api/pile/station";

export default {
    name: "MemberGroup",
    dicts: ["group_type"],
    data() {
        // 自定义校验
        var validatePass = (rule, value, callback) => {
            if (value === undefined || value === null || value.trim() === '') {
                callback(new Error('请输入集团名称'));
            } else if (value.length > 30) {
                callback(new Error('最多输入30个字'));
            } else {
                callback();
            }
        };
        return {
            openAddMember: false,
            // 遮罩层
            loading: true,
            // 选中数组
            ids: [],
            // 非单个禁用
            single: true,
            // 非多个禁用
            multiple: true,
            // 显示搜索条件
            showSearch: true,
            // 总条数
            total: 0,
            // 会员组表格数据
            memberGroupList: [],
            // 弹出层标题
            title: "",
            // 是否显示弹出层
            open: false,
            // 运营商列表
            merchantList: [],
            // 站点列表
            stationList: [],
            // 查询参数
            queryParams: {
                pageNum: 1,
                pageSize: 10,
                groupCode: null,
                merchantId: null,
                stationId: null,
                groupLevel: null,
                groupType: null,
                discount: null,
            },
            // 表单参数
            form: {
                groupName: null
            },
            // 表单校验
            rules: {},
            createMerchantVip: {},
            dialogRules: {
                groupName: [
                    { validator: validatePass, trigger: 'blur' }
                ],
            }
        };
    },
    created() {
        this.getList();
        this.getMerchantList();
    },
    methods: {
        // 获取运营商列表
        getMerchantList() {
            getMerchantListByAuth().then((response) => {
                console.log("response", response)
                this.merchantList = response.obj;
                this.createMerchantVip.targetMerchantId = this.merchantList[0].merchantId
            })
        },
        changeSelectStation(value) {
            console.log(value);
            // 通过接口查
            getStationListByMerchantId(value).then((response) => {
                this.stationList = response.data;
            });
        },
        /** 查询会员组列表 */
        getList() {
            this.loading = true;
            listMemberGroup(this.queryParams).then(response => {
                console.log('查询会员组列表', response);
                this.memberGroupList = response.rows;
                this.total = response.total;
                this.loading = false;
            });
        },
        // 取消按钮
        cancel() {
            this.open = false;
            this.reset();
        },
        // 表单重置
        reset() {
            this.form = {
                id: null,
                groupCode: null,
                merchantId: null,
                stationId: null,
                groupLevel: null,
                groupType: null,
                discount: null,
                createBy: null,
                createTime: null,
                updateBy: null,
                updateTime: null,
                delFlag: null
            };
            this.resetForm("form");
        },
        /** 搜索按钮操作 */
        handleQuery() {
            this.queryParams.pageNum = 1;
            this.getList();
        },
        /** 重置按钮操作 */
        resetQuery() {
            this.resetForm("queryForm");
            this.handleQuery();
        },
        // 多选框选中数据
        handleSelectionChange(selection) {
            this.ids = selection.map(item => item.id)
            this.single = selection.length !== 1
            this.multiple = !selection.length
        },
        /** 新增按钮操作 */
        handleAdd() {
            this.reset();
            this.open = true;
            this.title = "添加集团";
        },
        /** 修改按钮操作 */
        handleUpdate(row) {
            this.reset();
            const id = row.id || this.ids
            getMemberGroup(id).then(response => {
                this.form = response.data;
                this.open = true;
                this.title = "修改集团";
            });
        },
        /** 提交按钮 */
        submitForm() {
            this.$refs["form"].validate(valid => {
                if (valid) {
                    if (this.form.id != null) {
                        updateMemberGroup(this.form).then(response => {
                            this.$modal.msgSuccess("修改成功");
                            this.open = false;
                            this.getList();
                        });
                    } else {
                        addMemberGroup(this.form).then(response => {
                            this.$modal.msgSuccess("新增成功");
                            this.open = false;
                            this.getList();
                        });
                    }
                }
            });
        },
        /** 删除按钮操作 */
        handleDelete(row) {
            const ids = row.id || this.ids;
            this.$modal.confirm('是否确认删除会员组编号为"' + ids + '"的数据项？').then(function () {
                return delMemberGroup(ids);
            }).then(() => {
                this.getList();
                this.$modal.msgSuccess("删除成功");
            }).catch(() => { });
        },
        /** 导出按钮操作 */
        handleExport() {
            this.download('member/memberGroup/export', {
                ...this.queryParams
            }, `memberGroup_${new Date().getTime()}.xlsx`)
        },
    }
};
</script>
